<?php

namespace DeBear\ORM\Base\Helpers;

use Illuminate\Support\Facades\DB;
use PDO;
use DeBear\Repositories\DatabaseLogging;
use Illuminate\Database\Query\Builder as EloquentQueryBuilder;

class QueryBuilder
{
    /**
     * The internal name for the database connection this model uses
     * @var string
     */
    protected $conn_name;
    /**
     * The name of the database table
     * @var string
     */
    protected $class_name;
    /**
     * The Eloquent query builder instance we are piggy back off
     * @var EloquentQueryBuilder
     */
    protected $query;
    /**
     * Query pagination info
     * @var array
     */
    protected $paging;

    /**
     * Setup the internals for our object
     * @param string $class_name The full class name of the base model.
     * @param string $tbl_from   The name of the table from which to start the query (Optional).
     */
    public function __construct(string $class_name, ?string $tbl_from = null)
    {
        $this->class_name = $class_name;
        $this->conn_name = call_user_func([$this->class_name, 'getConnectionName']);
        if (!isset($tbl_from)) {
            $tbl_from = call_user_func([$this->class_name, 'getTable']);
        }
        $this->query = DB::connection($this->conn_name)->table($tbl_from);
    }

    /**
     * Mirror the EloquentQueryBuilder class by passing off to it to any method we have not implemented
     * @param string $name The name of the requested method (that we have not implemented).
     * @param array  $args The arguments passed to the requested method.
     * @return mixed The return value from the equivalent EloquentQueryBuilder call
     */
    public function __call(string $name, array $args): mixed
    {
        // Pass the request on to our EloquentQueryBuilder instance.
        $ret = call_user_func_array([$this->query, $name], $args);
        // In some instances, this is a return value.
        if (!is_object($ret) || get_class($ret) != EloquentQueryBuilder::class) {
            return $ret;
        }
        // But for the rest, we return our wrapper to allow chaining.
        $this->query = $ret;
        return $this;
    }

    /**
     * Mirror the EloquentQueryBuilder class by passing off to it any property we have not implemented
     * @param string $name The requested property (that we have not implemented).
     * @return mixed The return value of the EloquentQueryBuilder's property
     */
    public function __get(string $name): mixed
    {
        return $this->query->$name;
    }

    /**
     * Page our query, defined by a page number and (optional) rows-per-page
     * @param integer $page     The page number of the request we are processing.
     * @param integer $per_page The (optional) number of results to be returned for each page.
     * @return self The current EloquentQueryBuilder instance, updated to include our pagination info, for chaining
     */
    public function paginate(int $page, int $per_page = 10): self
    {
        $this->paging = ['page' => $page, 'per_page' => $per_page];
        $this->skip(($this->paging['page'] - 1) * $this->paging['per_page'])->take($this->paging['per_page']);
        return $this;
    }

    /**
     * Run the database query (replace EloquentQueryBuilder's query runner with our own)
     * @param array $opt Optional processing rules.
     * @return mixed The DeBearORM object with the appropriate results
     */
    public function get(array $opt = []): mixed
    {
        $sql = $this->query->toSql();
        $args = $this->query->getBindings();
        $pdo = $this->query->getConnection()->getPdo();
        // If appropriate add the SQL_CALC_FOUND_ROWS customisation.
        $inc_found_rows = false;
        if (stripos($sql, 'select ') === 0) {
            $sql = 'select SQL_CALC_FOUND_ROWS ' . substr($sql, 7);
            $inc_found_rows = true;
        }
        // Run the query using the SQL generated by the query builder.
        $bench_start = microtime(true);
        $sth = $pdo->prepare($sql);
        $sth->execute($args);
        $res = $sth->fetchAll(PDO::FETCH_ASSOC);
        $bench_stop = microtime(true);
        // Process the SQL_CALC_FOUND_ROWS?
        if ($inc_found_rows) {
            // Get the total number of rows.
            $count_bench_start = microtime(true);
            $count_sth = $pdo->prepare('SELECT FOUND_ROWS();');
            $count_sth->execute();
            $count_total = (int)$count_sth->fetchColumn();
            $count_bench_stop = microtime(true);
            // Add this to our benchmarking time (by implying it extended the end time).
            $bench_stop += ($count_bench_stop - $count_bench_start);
        }
        // Log the query.
        $bench = ($bench_stop - $bench_start) * 1000; // Converting the bench time from nanoseconds to milliseconds.
        DatabaseLogging::logORMQuery($this->conn_name, $sql, $args, $bench);
        // Build the info we'll pass to our object with relevant additional info.
        $extra = null;
        if (isset($this->paging)) {
            // How our query was paged.
            $extra = array_merge($extra ?? [], ['pagination' => $this->paging]);
        }
        if (isset($count_total)) {
            // The total number of rows that would have been returned.
            $extra = array_merge($extra ?? [], ['total-rows' => $count_total]);
        }
        // Create our new object.
        $class = $this->class_name;
        $obj = (new $class($res, ['trusted' => true], $extra));
        if (!isset($opt['info-query'])) {
            $obj->loadRequiredSecondaries();
        }
        return $obj;
    }

    /**
     * Return the internal representation we use for the debugging methods
     * @return array An internal representation of ourselves
     */
    public function debug(): array
    {
        return [
            'sql' => $this->query->toSql(),
            'args' => $this->query->getBindings(),
        ];
    }
}
